package me.Destro168.FC_Announcer;

import org.bukkit.configuration.file.FileConfiguration;

public class AnnouncementGroup 
{
	private FC_Announcer plugin;
	private FileConfiguration config;
	
	private final int LINE_GROUP_CAP = 1000;
	
	String[][] lines;
	int[] interval;
	boolean[] isActive;
	boolean[] isCreated;
	
	int announcementCount;
	int[] totalLines;
	int maxLines;
	//public int getMaxLines() { return maxLines; }
	
	public int getTotalLines(int x) { return totalLines[x]; }
	public int getInterval(int x) { return interval[x]; }
	public boolean getIsActive(int x) { return isActive[x]; }
	public boolean getIsCreated(int x) { return isCreated[x]; }
	
	public int getAnnouncementCount() { return announcementCount; }
	
	public double getBlock1X(int group) { return config.getInt("Announcement." + group + ".x1"); }
	public double getBlock1Y(int group) { return config.getInt("Announcement." + group + ".y1"); }
	public double getBlock1Z(int group) { return config.getInt("Announcement." + group + ".z1"); }
	public double getBlock2X(int group) { return config.getInt("Announcement." + group + ".x2"); }
	public double getBlock2Y(int group) { return config.getInt("Announcement." + group + ".y2"); }
	public double getBlock2Z(int group) { return config.getInt("Announcement." + group + ".z2"); }
	
	public AnnouncementGroup()
	{
		//Housekeeping
		plugin = FC_Announcer.plugin;
		
		//Start the announcementGroup code.
		initialize();
	}
	
	public void setIsActive(int group, boolean y) 
	{
		config = plugin.getConfig();
		isActive[group] = y;
		config.set("Announcement." + group + ".isActive", y);
		plugin.saveConfig();
	}
	
	public Boolean editLine(int group, int line, String text)
	{
		boolean isEmpty = false;
		
		config = plugin.getConfig();
		
		if (lines[group][line].equals(""))
			isEmpty = true;
		
		lines[group][line] = text;
		config.set("Announcement." + group + "." + line, text);

		plugin.saveConfig();
		
		return isEmpty;
	}
	
	public void setInterval(int group, int interval_)
	{
		config = plugin.getConfig();
		interval[group] = interval_;
		config.set("Announcement." + group + ".interval", interval_);
		plugin.saveConfig();
	}
	
	//Careful with this function, uses initialize, very costly to use rearrange()
	public void clearAnnouncement(int group)
	{
		config = plugin.getConfig();
		config.set(("Announcement." + group), null);
		initialize();
		plugin.saveConfig();
	}
	
	public void createNewAnnouncement(int group, int line, String text)
	{
		config = plugin.getConfig();
		
		config.set("Announcement." + group + ".isCreated", true); //Set active
		config.set("Announcement." + group + ".isActive", true);
		config.set("Announcement." + group + ".interval", 60);
		
		config.set("Announcement." + group + ".x1", 0);
		config.set("Announcement." + group + ".y1", 0);
		config.set("Announcement." + group + ".z1", 0);
		config.set("Announcement." + group + ".x2", 0);
		config.set("Announcement." + group + ".y2", 0);
		config.set("Announcement." + group + ".z2", 0);
		
		config.set("Announcement." + group + "." + line, text);
		
		plugin.saveConfig();
	}
	
	public void setAnnouncementZone(int group, int x1, int y1, int z1, int x2, int y2, int z2)
	{
		config = plugin.getConfig();
		
		config.set("Announcement." + group + ".x1", x1);
		config.set("Announcement." + group + ".y1", y1);
		config.set("Announcement." + group + ".z1", z1);
		config.set("Announcement." + group + ".x2", x2);
		config.set("Announcement." + group + ".y2", y2);
		config.set("Announcement." + group + ".z2", z2);

		plugin.saveConfig();
	}
	
	//Move an announcement as well as all of it's line to another position
	public void moveAnnouncement(int startPosition, int newPostion)
	{
		String old = "Announcement." + startPosition;
		String newAnnounce = "Announcement." + newPostion;
		String line = "";
		
		config.set(newAnnounce + ".isCreated", config.get(old + ".isCreated"));
		config.set(newAnnounce + ".isActive", config.get(old + ".isActive"));
		config.set(newAnnounce + ".interval", config.get(old + ".interval"));
		
		config.set(newAnnounce + ".x1", config.get(old + ".x1"));
		config.set(newAnnounce + ".y1", config.get(old + ".y1"));
		config.set(newAnnounce + ".z1", config.get(old + ".z1"));
		config.set(newAnnounce + ".x2", config.get(old + ".x2"));
		config.set(newAnnounce + ".y2", config.get(old + ".y2"));
		config.set(newAnnounce + ".z2", config.get(old + ".z2"));
		
		//For all lines
		for (int i = 0; i < LINE_GROUP_CAP; i++)
		{
			line = config.getString(old + "." + i);
			
			//If the old announcement isn't empty or null.
			if (line != null && !isBlankString(line))
			{
				config.set(newAnnounce + "." + i, config.getString(old + "." + i));
			}
		}
		
		//Remove the whole old announcement.
		config.set(old, null);
	}
	
	public void initialize()
	{
		//Get config
		config = plugin.getConfig();

		//Initialize variables
		lines = new String[FC_Announcer.cap][FC_Announcer.cap];
		totalLines = new int[FC_Announcer.cap];
		interval = new int[FC_Announcer.cap];
		isActive = new boolean[FC_Announcer.cap];
		isCreated = new boolean[FC_Announcer.cap];
		
		for (int i = 0; i < FC_Announcer.cap; i++)
		{
			for (int j = 0; j < FC_Announcer.cap; j++)
			{
				lines[i][j] = "";
			}
			
			totalLines[i] = 0;
			interval[i] = -1;
			isActive[i] = false;
			isCreated[i] = true;
		}
		
		//Load up announcements from config file.
		loadAnnouncements();
		
		plugin.saveConfig();
	}
	
	public void rearrangeAnnouncements(int startingPoint)
	{
		String line = "";
		String line2 = "";
		
		//For all announcements in the config...
		for (int i = startingPoint; i < LINE_GROUP_CAP; i++)
		{
			//If the announcement was created...
			if (config.getBoolean("Announcement." + i + ".isCreated") == true)
			{
				//First we want to try to stack the lines down
				for (int j = 0; j < LINE_GROUP_CAP; j++)
				{
					line = config.getString("Announcement." + i + "." + j);
					
					//Find a good announcement line
					if (line != null && !isBlankString(line))
					{
						//For all announcement lines below that, if it's blank, then move to that.
						for (int k = 0; k < j; k++)
						{
							line2 = config.getString("Announcement." + i + "." + k);
							
							if (line2 == null || isBlankString(line2))
							{
								config.set("Announcement." + i + "." + k, config.get("Announcement." + i + "." + j));
								config.set("Announcement." + i + "." + j, null);
								k = j;
							}
						}
					}
				}
				
				//If there are any empty spaces below the announcement group, shift the announcement down.
				for (int j = 0; j < i; j++)
				{
					if (config.getBoolean("Announcement." + j + ".isCreated") == false)
					{
						moveAnnouncement(i, j);
						j = i;
					}
				}
			}
		}
	}

	public void loadAnnouncements()
	{
		config = plugin.getConfig();

		String line = "";
		int lineCount = 0;
		
		announcementCount = 0;
		maxLines = 0;
		
		//Fix announcements so that they do not stack
		rearrangeAnnouncements(0);
		
		for (int i = 0; i < LINE_GROUP_CAP; i++)
		{
			//If the announcement was created...
			if (config.getBoolean("Announcement." + i + ".isCreated") == true)
			{
				//Get interval from file.
				interval[i] = config.getInt("Announcement." + i + ".interval");
				
				//Get isActive from config
				isActive[i] = config.getBoolean("Announcement." + i + ".isActive");
				
				//Set isCreated to true.
				isCreated[i] = true;
				
				//Store lines from the announcement.
				for (int j = 0; j < LINE_GROUP_CAP; j++)
				{
					//Get line from config.
					line = config.getString("Announcement." + i + "." + j);
					
					//If the line isn't empty, then we store it
					if (line != null && isBlankString(line) == false)
					{
						//Store the line in memory.
						lines[i][j] = line;
						
						//Increase totalLines
						totalLines[i]++;
					}
				}
				
				//Attempt to update maxLines
				if (lineCount > maxLines)
					maxLines = lineCount;
				
				//Increase number of announcements
				announcementCount++;
			}
		}
		
		plugin.saveConfig();
	}
	
	public boolean clearLine(int group, int line)
	{
		//Attempt to clear a line
		try
		{
			//If the line has text, then...
			if (!lines[group][line].equals(""))
			{
				//change the lines text
				setLine("", group, line);
				
				//decrease totalLines
				totalLines[group]--;
				
				//If there are no announcements left, then remove the announcement group.
				if (totalLines[group] == 0)
					clearAnnouncement(group);
			}
			
			//Return true for success.
			return true;
		}
		catch (ArrayIndexOutOfBoundsException e)
		{
			return false;
		}
	}
	
	public String getLine(int group, int line)
	{	
		//Attempt to return the line specified by user.
		try
		{
			return lines[group][line];
		}
		catch (ArrayIndexOutOfBoundsException e)
		{
			return "";
		}
	}

	//Sets a line both in memory and in the config.
	public void setLine(String text, int group, int linePosition)
	{
		config = plugin.getConfig();
		
		try
		{
			//If the group specified is created, then add a new line.
			if (isCreated[group] == true)
			{
				//Edit the line and if the line was empty, then we want to increase totalLines.
				if (editLine(group, linePosition, text) == true)
					totalLines[group]++;
			}
			else
				createNewAnnouncement(group, linePosition, text);
		}
		catch (ArrayIndexOutOfBoundsException e) {}

		plugin.saveConfig();
	}
	
	//Enables all non-empty announcements.
	public void autoEnable()
	{
		//Set all non-empty announcements to active
		for (int i = 0; i < announcementCount; i++) 
		{
			if (totalLines[i] > 0)
			{
				setIsActive(i, true);
			}
		}
	}
	
	public Boolean isBlankString(String text)
	{
		if ((text.equals("")) || (text.equals("null")))
			return true;
		
		return false;
	}
}


//this.log.info("[FC_Announcer] Failed to find announcement.");


