package me.Destro168.FC_Announcer;

import me.Destro168.FC_General.ColorLib;
import me.Destro168.FC_General.MessageLib;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class AnnouncerCE implements CommandExecutor
{
	private FC_Announcer plugin;
	Player playerSender;
	MessageLib msgLib;
	
	public AnnouncerCE() { }
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args2)
    {
		//Variable Declarations
		plugin = FC_Announcer.plugin;
		String[] args = new String[50];
		boolean success = true;
		playerSender = (Player) sender;
		msgLib = new MessageLib(playerSender);
		
		//Initialize arguments.
		for (int i = 0; i < args2.length; i++)
		{
			args[i] = args2[i];
		}
		
		//Check 1 argument commands.
		if (args[0] != null)
		{
			if (args[0].equalsIgnoreCase("list")) 
			{
				if (args[1] == null) 
					commandList("0");
				else 
					commandList(args[1]);

				return true;
			}
			
			if (args[0].equalsIgnoreCase("vert"))
				return commandVert(playerSender);
		}
		
		//Check 2 argument commands.
		if (args[1] == null)
		{
			commandHelp();
			return true;
		}
		else
		{ //else if (args[0].equalsIgnoreCase("deletaall")) success = commandDeleteAll(args[1]);
			if (args[0].equalsIgnoreCase("off") || args[0].equalsIgnoreCase("disable")) success = commandOff(args[1]);
			else if (args[0].equalsIgnoreCase("on") || args[0].equalsIgnoreCase("enable")) success = commandOn(args[1]);		
			else if (args[0].equalsIgnoreCase("set")) success = commandSet(args);
			else if (args[0].equalsIgnoreCase("delete")) success = commandDelete(args[1], args[2]);
			else if (args[0].equalsIgnoreCase("interval")) success = commandInterval(args[1], args[2]);
			else if (args[0].equalsIgnoreCase("zone")) success = commandZone(args[1], playerSender);
			else if (args[0].equalsIgnoreCase("help")) commandHelp();
			else msgLib.errorInvalidCommand();
		}
		
		//Give success or failure feedback
		if (success == false)
			msgLib.errorInvalidCommand();
		
		return false;
	}

	//For command /announcer off [group]
	public boolean commandOff(String group)
	{
		//Variables
		int inputGroup;
		
		try
		{
			inputGroup = Integer.valueOf(group);
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		//First process the command if the user entered all.
		if (group.equalsIgnoreCase("all")) 
		{
			//Cancel all current announcements.
			Bukkit.getScheduler().cancelTasks(plugin);
			
			//For all groups, iterate through as i.
			for (int i = 0; i < FC_Announcer.am.getAnnouncementGroup().getAnnouncementCount(); i++)
			{	
				//Set the group to no longer recieve announcements.
				FC_Announcer.am.getAnnouncementGroup().setIsActive(i, false);
			}
		}
		else 
		{
			//If the announcement is active
			if (FC_Announcer.am.getAnnouncementGroup().getIsActive(inputGroup) == true)
			{
				//Cancel the announcement task.
				Bukkit.getServer().getScheduler().cancelTask(FC_Announcer.am.getTaskId(inputGroup));
				
				//Set the group to no longer recieve announcements. 
				FC_Announcer.am.getAnnouncementGroup().setIsActive(inputGroup, false);
			}
			else
				return false;
		}
		
		msgLib.successCommand();
		
		return true;
	}
	
	//For command /announcer on [group]
	public boolean commandOn(String group)
	{
		//Variables
		int inputGroup = 0;
		int newAnnouncementTaskId = 0;
		
		try
		{
			inputGroup = Integer.valueOf(group);
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		//First process the command if the user entered all.
		if (group.equalsIgnoreCase("all"))
		{
			//For all groups, iterate through as i.
			for (int i = 0; i < FC_Announcer.am.getAnnouncementGroup().getAnnouncementCount(); i++)
			{	
				//Set the group to recieve announcements.
				FC_Announcer.am.getAnnouncementGroup().setIsActive(i, true);

				//Start all announcements for all groups.
				FC_Announcer.am.setTaskId(i, FC_Announcer.am.startAnnouncement(FC_Announcer.am.getTaskId(i), i));
			}
		}
		else
		{
			//If the announcement is inactive
			if (FC_Announcer.am.getAnnouncementGroup().getIsActive(inputGroup) == false)
			{
				//Set the group to recieve announcements.
				FC_Announcer.am.getAnnouncementGroup().setIsActive(inputGroup, true);
				
				//Start announcement.
				newAnnouncementTaskId = FC_Announcer.am.startAnnouncement(FC_Announcer.am.getTaskId(inputGroup), inputGroup);
				
				//Store task id.
				FC_Announcer.am.setTaskId(inputGroup, newAnnouncementTaskId);
			}
			else
			{
				return false;
			}
		}
		
		msgLib.successCommand();
		
		return true;
	}
	
	//If the command sent is /announcer set [group] [line #] [msg]
	public boolean commandSet(String[] args)
	{
		//Variables
		int arrayLength = args.length;
		String message = "";
		int group;
		int line;
		
		if (args[1] == null)
			return false;
		else if (args[2] == null)
			return false;
		else if (args[3] == null)
			return false;
		
		//Attempt to store two arguments as numbers.
		try 
		{
			group = Integer.parseInt(args[1]);
			line = Integer.parseInt(args[2]);
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		//We have to merg all the arguments after the "line" argument to create the message.
		for (int i = 3; i < arrayLength; i++) {
			if (i == 3)
				message = args[i];
			else
			{
				if (args[i] != null)
					message = message + " " + args[i];
			}
		}
		
		//Set the announcement line to the one specified.
		FC_Announcer.am.getAnnouncementGroup().setLine(message, group, line);
		
		//Give the player feedback
		msgLib.successCommand();
				
		//Reload announcements.
		FC_Announcer.am.reload();
		
		return true;
	}
	
	//If the command sent is /announcer deleteall
	public boolean commandDeleteAll(String group)
	{	
		//Clear all announcement groups.
		for (int i = 0; i < FC_Announcer.am.getAnnouncementGroup().getAnnouncementCount(); i++) 
			FC_Announcer.am.getAnnouncementGroup().clearAnnouncement(i);

		return true;
	}
	
	//Command: /announcer delete [group] [line #]
	public boolean commandDelete(String group, String line)
	{
		//Delete specified announcement and line
		try 
		{
			FC_Announcer.am.getAnnouncementGroup().clearLine(Integer.parseInt(group), Integer.parseInt(line));
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		//Restart the announcements
		FC_Announcer.am.reload();
		
		//Send feedback
		msgLib.successCommand();
		
		return true;
	}
	
	//Command: /announcer list [group]
	public void commandList(String group)
	{
		//Variables
		String message = "";
		String line = "";
		int listCounter = 0;
		int intGroup;
		ColorLib colorlib = new ColorLib();
		MessageLib msgLib = new MessageLib(playerSender);
		
		//If the user enters in "groups", then display all groups that are active.
		if (group.equals("groups"))
		{
			//Display all announcements
			for (int i = 0; i != FC_Announcer.am.getAnnouncementGroup().getAnnouncementCount(); i++) 
			{
				if (FC_Announcer.am.getAnnouncementGroup().getIsActive(i) == true)
				{
					msgLib.cm(6, "Group " + ChatColor.GRAY + "[" + ChatColor.WHITE + String.valueOf(i) + ChatColor.GRAY + ", " + ChatColor.WHITE + "Enabled" +
							ChatColor.GRAY + "] - Interval - [" + ChatColor.WHITE + FC_Announcer.am.getAnnouncementGroup().getInterval(i) + ChatColor.GRAY + "]");
				}
				else
				{
					msgLib.cm(6, "Group " + ChatColor.GRAY + "[" + ChatColor.WHITE + String.valueOf(i) + ChatColor.GRAY + ", " + ChatColor.WHITE + "Disabled (inactive)" +
							ChatColor.GRAY + "]");
				}
			}
		}
		
		else
		{
			//Attempt to store group.
			try
			{
				intGroup = Integer.parseInt(group);
				
				//Make sure input is in range.
				if ((intGroup > FC_Announcer.cap) || (intGroup < 0))
					return;
			}
			catch (NumberFormatException e)
			{
				group = "0";
				intGroup = 0;
			}
			
			//Display all announcements
			for (int i = 0; i != FC_Announcer.am.getAnnouncementGroup().getTotalLines(intGroup); i++) 
			{
				//Store announcement in "message" and then send it to the player.
				line = FC_Announcer.am.getAnnouncementGroup().getLine(intGroup, i);
				
				//Do a check to make sure the announcement actually has words before listing.
				if ((line != null) && (!(line.equals(""))) && (!(line.equals("null"))))
				{ 
					//Add all the prefixy stuff.
					message = "Line #" + ChatColor.WHITE + String.valueOf(i) + ChatColor.GRAY + " - [" + ChatColor.WHITE + "";
					
					if (FC_Announcer.am.getAnnouncementGroup().getIsActive(intGroup) == true)
						message += "On";
					else
						message += "Off";
					
					message += ChatColor.GRAY + "] [" + ChatColor.WHITE + FC_Announcer.am.getAnnouncementGroup().getInterval(intGroup) + ChatColor.GRAY + "] - " + ChatColor.WHITE + colorlib.parseColors(line);
					
					msgLib.cm(6, message);
					
					listCounter++;
				}
				//else {
				//	playerSender.sendMessage(ChatColor.DARK_GREEN + "#" + String.valueOf(i) + ":" + ChatColor.GREEN + " No announcement."); 
				//}	
			}
			
			//If no announcements none were listed, tell the player. This is ensure a given response if the player uses the command.
			if (listCounter == 0) {	playerSender.sendMessage(ChatColor.DARK_GREEN + "There are currently no announcements stored in this group."); }
		}
	}
	
	//Command: /announcer interval [group] [interval]
	public boolean commandInterval(String group, String interval)
	{
		//Variables
		int intGroup;
		int intInterval;
		
		//Attempt to store input as numbers
		try
		{
			intGroup = Integer.parseInt(group);
			intInterval = Integer.parseInt(interval);
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		//Make sure input is in range.
		if ((intGroup > FC_Announcer.cap) || (intGroup < 0))
			return false;
		
		if (intInterval > 0)
		{
			FC_Announcer.am.getAnnouncementGroup().setInterval(intGroup, intInterval);
			
			//Send feedback
			msgLib.successCommand();
			
			FC_Announcer.am.reload();
			
			return true;
		}
		else
		{
			return false;
		}
	}
	
	private boolean commandZone(String group, Player player)
	{
		//Variable Declarations
		int inputGroup;
		Location loc1;
		Location loc2;
		
		try
		{
			inputGroup = Integer.valueOf(group);
		}
		catch (NumberFormatException e)
		{
			return false;
		}
		
		if (FC_Announcer.block1Location.containsKey(player) && FC_Announcer.block2Location.containsKey(player))
		{
			loc1 = FC_Announcer.block1Location.get(player);
			loc2 = FC_Announcer.block2Location.get(player);
			
			FC_Announcer.am.getAnnouncementGroup().setAnnouncementZone(inputGroup,
				(int) loc1.getX(),
				(int) loc1.getY(),
				(int) loc1.getZ(),
				(int) loc2.getX(),
				(int) loc2.getY(),
				(int) loc2.getZ()
			);
			
			msgLib.successCommand();
		}
		else
		{
			player.sendMessage(ChatColor.RED + "Define zones first.");
		}
		
		return true;
	}
	
	public boolean commandVert(Player player)
	{
		//Variable Declarations
		Location loc1;
		Location loc2;
		
		if (FC_Announcer.block1Location.containsKey(player) && FC_Announcer.block2Location.containsKey(player))
		{
			loc1 = FC_Announcer.block1Location.get(player);
			loc1.setY(0);
			FC_Announcer.block1Location.put(player, loc1);
			
			loc2 = FC_Announcer.block2Location.get(player);
			loc2.setY(999);
			FC_Announcer.block2Location.put(player, loc2);
			
			msgLib.successCommand();
		}
		else
			return false;
		
		return true;
	}
	
	//If the player sends /announcer help, display all commands.
	public void commandHelp()
	{
		MessageLib msgLib = new MessageLib(playerSender);
		
		//Send help messages to the player
		msgLib.cm(98, "Help for FC_Announcer!");
		msgLib.cm2(0, "/announcer help","Displays this help!");
		msgLib.cm2(0, "/announcer on [group]","Disables Group.");
		msgLib.cm2(0, "/announcer off [group]","Enables Group.");
		msgLib.cm2(0, "/announcer delete [group] [line]","Deletes line of group.");
		msgLib.cm(6, "/announcer list [groups, group number]:");
		msgLib.cm(8,"- Enter a group number to see its lines or type 'groups' to see group info.");
		msgLib.cm(6, "/announcer set [group] [line] [msg1] [msg2] [...]:");
		msgLib.cm(8,"- Sets announcement at specified group and line to msg.");
		msgLib.cm(6, "/announcer interval [group] [interval in seconds]:");
		msgLib.cm(8,"- Allows you to change how often an announcement occurs.");
		msgLib.cm(6, "/announcer zone [group]");
		msgLib.cm(8,"- To select a region, use a stick and right-click two blocks. Then");
		msgLib.cm(8,"- use this command to define the zone for any group.");
		msgLib.cm2(0, "/announcer vert","Expands zone selection from sky level to bedrock.");
	}
}
